
#include "cuda_defs.h"


#define LOG_ALPH_SIZE  2
#define ALPH_SIZE  (1 << LOG_ALPH_SIZE)
#define MATRIX_MAX_LENGTH 200

#define PARALLEL_COPY

#define PROG_FLAVOUR "" // "-posloop"

#define LOG_GRID_X 6 // enumeration 
#define LOG_GRID_Y 0 // precision
// #define LOG_GRID_Z 0 // slices
#define LOG_NB_BLOCKS  (LOG_GRID_X + LOG_GRID_Y) // even


#define NB_GRID_X (1 << LOG_GRID_X)
#define NB_GRID_Y (1 << LOG_GRID_Y)
#define NB_GRID_Z  N

#define NB_BLOCKS (1 << LOG_NB_BLOCKS)



#ifdef  __DEVICE_EMULATION__
#define NB_BLOCKS_SCAN 2
#define LOG_NB_THREADS_PER_BLOCK 2 // even
#define LOG_NB_THREADS_PER_BLOCK_SCAN 2 
#else
#define NB_BLOCKS_SCAN (1 << 8)
#define LOG_NB_THREADS_PER_BLOCK 6 // even
#define LOG_NB_THREADS_PER_BLOCK_SCAN 6
#endif

#define NB_THREADS_PER_BLOCK (1 << LOG_NB_THREADS_PER_BLOCK)
// NB_THREADS_PER_BLOCK  = blockDim.x


#define LOG_NB_THREADS (LOG_NB_BLOCKS + LOG_NB_THREADS_PER_BLOCK)
#define NB_THREADS (1 << LOG_NB_THREADS)

#define NB_THREADS_PER_BLOCK_SCAN (1 << LOG_NB_THREADS_PER_BLOCK_SCAN)
#define NB_THREADS_SCAN (NB_BLOCKS_SCAN * NB_THREADS_PER_BLOCK_SCAN)

#define DFT_MATRIX "../matrices/m60"
#define DFT_MATRIX_TWO  "../matrices/m60"




// BUCKETS

#define SLICE_MAX_LENGTH 40
#define MAX_LENGTH_PER_SLICE  25   // maximum length for the enumeration (time, bits)
#define AUTOMATIC_N  10

#ifdef COMPARE

#define NB_BUCKETS (60)
#define NB_ALL_BUCKETS  (NB_BUCKETS * NB_BUCKETS)

#else

#define NB_BUCKETS (3600) // (256) // 3600)
#define NB_ALL_BUCKETS  (NB_BUCKETS)

#endif
#define BIG_NB_BUCKETS  (NB_ALL_BUCKETS * NB_GRID_Y)

typedef unsigned  int   count ;      // sur shared. short ?
typedef unsigned long  int   dcount ;    // sur device
typedef double   hcount ;   // on the host / histograms // long long ?




// SCAN

// maximal length of an input matrix
#define MATRIX_MAX_LENGTH_SCAN 31
// maximal sum of length of all input matrices
// 300 required for all JASPAR matrices to be loaded in shared memory at once
#define MAX_TOTAL_LENGTH 300

// length of the text segment for each thread
#define SEGMENT_LENGTH_SHARED (2048) 

// #define POS_LOOP 1
// #define POS_LOOP_STOP (-(2*POS_LOOP))

// parameters for the Wu et al. 2000 improvement
// first position in the matrix where the Wu function is not used
#define INDEX_NO_WU  6  
// #define WU_BEST
// #define WU_WORST


// parameters for the Liefooghe et al. 2006 improvement
// #define SLICES
// #define SLICES_IN_SHARED

#ifdef SLICES_IN_SHARED
#define SLICEWIDTH 2
#define NBMAT_PER_SLICE 7
#else
#define SLICEWIDTH 7
#define NBMAT_PER_SLICE 50
#endif

#define SLICESIZE (1 << (2 * SLICEWIDTH))
#define NBSLICES ((MATRIX_MAX_LENGTH_SCAN / SLICEWIDTH) + 1)

#define THREADS_INTERLEAVED

// parameters for the outpur of results
#define SCORES_OUT
#define RES_PER_THREAD (2*64)

