/*
  TFM-CUDA
  Copyright (C) 2008-2010  Mathieu Giraud & Jean-Stéphane Varré
  http://bioinfo.lifl.fr/TFM/TFM-CUDA/ 

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <time.h>
#include <sys/time.h>

struct timeval tv1,tv2;
struct timezone tz;

void color(int c)
{
  printf("%c[%dm", 0x1B, c);
}

void time_start()
{
  color(35);
  printf("\n== Time reset\n");
  color(0);
  gettimeofday(&tv1, &tz);
}


void time_stop()
{
  gettimeofday(&tv2, &tz);
  float diff=(tv2.tv_sec-tv1.tv_sec) + (float) (tv2.tv_usec-tv1.tv_usec) / 1000000L ;
  
  color(35);
  printf("== Wall-clock time: %3.3f s\n\n", diff);
  color(0);
}


void print_sizeofs()
{
	printf("sizeof(long): %ld \n", sizeof(long));
	printf("sizeof(int): %ld \n", sizeof(int));
	printf("sizeof(float): %ld \n", sizeof(float));
	printf("sizeof(double): %ld \n", sizeof(double));
}
